// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.decorator.invert;

import '../node.dart';
import '../decorator.dart';

/// The inverter decorator inverts the response given by a node contained within it, returning true if the contained node returned false, and vice versa.
/// If conditions follow the 'is' true convention, i.e. all the conditions check if something 'is' working or a property 'is' present, rather than 'is not', then
///  when-ever a condition needs to find out if something 'is not' true it can simply be wrapped in this inverter decorator rather than creating an additional node for the task.
Decorator invert = (Map blackboard, Node node) async {
  return !await node(blackboard);
};