// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.test.decorator.invert;

import 'package:test/test.dart';
import 'package:functional_behaviour_tree/functional_behaviour_tree.dart';
import 'nodes/isHttpStatus.dart';

invert_test() {
  group('Invert', () {

    Node notHttpStatusCode404;

    setUp(() {
      // Assign function expression
      notHttpStatusCode404 = (Map blackboard) => invert(blackboard, isHttpStatusCode404);
    });

    test('Can invert true to false', () {
      return invert({'http_status_code' : '404'}, isHttpStatusCode404).then((bool value) { expect(value, isFalse); });
    });

    test('Can invert false to true', () {
      return invert({'http_status_code' : '401'}, isHttpStatusCode404).then((bool value) { expect(value, isTrue); });
    });

  });
}